# Class BMPImageWriteParam

java.lang.Object
javax.imageio.IIOParam
javax.imageio.ImageWriteParam
javax.imageio.plugins.bmp.BMPImageWriteParam

public class BMPImageWriteParam extends ImageWriteParam
A subclass of `ImageWriteParam` for encoding images in the BMP format.

This class allows for the specification of various parameters while writing a BMP format image file. By default, the data layout is bottom-up, such that the pixels are stored in bottom-up order, the first scanline being stored last.

The particular compression scheme to be used can be specified by using the `setCompressionType()` method with the appropriate type string. The compression scheme specified will be honored if and only if it is compatible with the type of image being written. If the specified compression scheme is not compatible with the type of image being written then the `IOException` will be thrown by the BMP image writer. If the compression type is not set explicitly then `getCompressionType()` will return `null`. In this case the BMP image writer will select a compression type that supports encoding of the given image without loss of the color resolution.

The compression type strings and the image type(s) each supports are listed in the following table:

Compression Types
Type String | Description | Image Types
--- | --- | ---
BI_RGB | Uncompressed RLE | <= 8-bits/sample
BI_RLE8 | 8-bit Run Length Encoding | <= 8-bits/sample
BI_RLE4 | 4-bit Run Length Encoding | <= 4-bits/sample
BI_BITFIELDS | Packed data | 16 or 32 bits/sample

## Field Summary

### Fields declared in class ImageWriteParam

`canOffsetTiles, canWriteCompressed, canWriteProgressive, canWriteTiles, compressionMode, compressionQuality, compressionType, compressionTypes, locale, MODE_COPY_FROM_METADATA, MODE_DEFAULT, MODE_DISABLED, MODE_EXPLICIT, preferredTileSizes, progressiveMode, tileGridXOffset, tileGridYOffset, tileHeight, tileWidth, tilingMode, tilingSet`
Modifier and Type
Field
Description
`protected boolean`
`canOffsetTiles`
A `boolean` that is `true` if this `ImageWriteParam` allows tiling grid offset parameters to be set.
`protected boolean`
`canWriteCompressed`
A `boolean` that is `true` if this writer can write images using compression.
`protected boolean`
`canWriteProgressive`
A `boolean` that is `true` if this `ImageWriteParam` allows images to be written as a progressive sequence of increasing quality passes.
`protected boolean`
`canWriteTiles`
A `boolean` that is `true` if this `ImageWriteParam` allows tile width and tile height parameters to be set.
`protected int`
`compressionMode`
The mode controlling compression settings, which must be set to one of the four `MODE_*` values.
`protected float`
`compressionQuality`
A `float` containing the current compression quality setting.
`protected String`
`compressionType`
A `String` containing the name of the current compression type, or `null` if none is set.
`protected String[]`
`compressionTypes`
An array of `String`s containing the names of the available compression types.
`protected Locale`
`locale`
A `Locale` to be used to localize compression type names and quality descriptions, or `null` to use a default `Locale`.
`static final int`
`MODE_COPY_FROM_METADATA`
A constant value that may be passed into methods such as `setTilingMode`, `setProgressiveMode`, or `setCompressionMode` to enable that feature for future writes.
`static final int`
`MODE_DEFAULT`
A constant value that may be passed into methods such as `setTilingMode`, `setProgressiveMode`, and `setCompressionMode` to enable that feature for future writes.
`static final int`
`MODE_DISABLED`
A constant value that may be passed into methods such as `setTilingMode`, `setProgressiveMode`, and `setCompressionMode` to disable a feature for future writes.
`static final int`
`MODE_EXPLICIT`
A constant value that may be passed into methods such as `setTilingMode` or `setCompressionMode` to enable a feature for future writes.
`protected Dimension[]`
`preferredTileSizes`
An array of preferred tile size range pairs.
`protected int`
`progressiveMode`
The mode controlling progressive encoding, which must be set to one of the four `MODE_*` values, except `MODE_EXPLICIT`.
`protected int`
`tileGridXOffset`
The amount by which the tile grid origin should be offset horizontally from the image origin if tiling has been set, or 0 otherwise.
`protected int`
`tileGridYOffset`
The amount by which the tile grid origin should be offset vertically from the image origin if tiling has been set, or 0 otherwise.
`protected int`
`tileHeight`
The height of each tile if tiling has been set, or 0 otherwise.
`protected int`
`tileWidth`
The width of each tile if tiling has been set, or 0 otherwise.
`protected int`
`tilingMode`
The mode controlling tiling settings, which Must be set to one of the four `MODE_*` values.
`protected boolean`
`tilingSet`
A `boolean` that is `true` if tiling parameters have been specified.

### Fields declared in class IIOParam

`controller, defaultController, destinationOffset, destinationType, sourceBands, sourceRegion, sourceXSubsampling, sourceYSubsampling, subsamplingXOffset, subsamplingYOffset`
Modifier and Type
Field
Description
`protected IIOParamController`
`controller`
The `IIOParamController` that will be used to provide settings for this `IIOParam` object when the `activateController` method is called.
`protected IIOParamController`
`defaultController`
The default `IIOParamController` that will be used to provide settings for this `IIOParam` object when the `activateController` method is called.
`protected Point`
`destinationOffset`
The offset in the destination where the upper-left decoded pixel should be placed.
`protected ImageTypeSpecifier`
`destinationType`
An `ImageTypeSpecifier` to be used to generate a destination image when reading, or to set the output color type when writing.
`protected int[]`
`sourceBands`
An array of `int`s indicating which source bands will be used, or `null`.
`protected Rectangle`
`sourceRegion`
The source region, on `null` if none is set.
`protected int`
`sourceXSubsampling`
The decimation subsampling to be applied in the horizontal direction.
`protected int`
`sourceYSubsampling`
The decimation subsampling to be applied in the vertical direction.
`protected int`
`subsamplingXOffset`
A horizontal offset to be applied to the subsampling grid before subsampling.
`protected int`
`subsamplingYOffset`
A vertical offset to be applied to the subsampling grid before subsampling.

## Constructor Summary

Constructors
Constructor
Description
`BMPImageWriteParam()`
Constructs an `BMPImageWriteParam` object with default values for all parameters and a `null Locale`.
`BMPImageWriteParam(Locale locale)`
Constructs a `BMPImageWriteParam` set to use a given `Locale` and with default values for all parameters.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isTopDown()`
Returns the value of the `topDown` parameter.
`void`
`setTopDown(boolean topDown)`
If set, the data will be written out in a top-down manner, the first scanline being written first.

### Methods declared in class ImageWriteParam

`canOffsetTiles, canWriteCompressed, canWriteProgressive, canWriteTiles, getBitRate, getCompressionMode, getCompressionQuality, getCompressionQualityDescriptions, getCompressionQualityValues, getCompressionType, getCompressionTypes, getLocale, getLocalizedCompressionTypeName, getPreferredTileSizes, getProgressiveMode, getTileGridXOffset, getTileGridYOffset, getTileHeight, getTileWidth, getTilingMode, isCompressionLossless, setCompressionMode, setCompressionQuality, setCompressionType, setProgressiveMode, setTiling, setTilingMode, unsetCompression, unsetTiling`
Modifier and Type
Method
Description
`boolean`
`canOffsetTiles()`
Returns `true` if the writer can perform tiling with non-zero grid offsets while writing.
`boolean`
`canWriteCompressed()`
Returns `true` if this writer supports compression.
`boolean`
`canWriteProgressive()`
Returns `true` if the writer can write out images as a series of passes of progressively increasing quality.
`boolean`
`canWriteTiles()`
Returns `true` if the writer can perform tiling while writing.
`float`
`getBitRate(float quality)`
Returns a `float` indicating an estimate of the number of bits of output data for each bit of input image data at the given quality level.
`int`
`getCompressionMode()`
Returns the current compression mode, if compression is supported.
`float`
`getCompressionQuality()`
Returns the current compression quality setting.
`String[]`
`getCompressionQualityDescriptions()`
Returns an array of `String`s that may be used along with `getCompressionQualityValues` as part of a user interface for setting or displaying the compression quality level.
`float[]`
`getCompressionQualityValues()`
Returns an array of `float`s that may be used along with `getCompressionQualityDescriptions` as part of a user interface for setting or displaying the compression quality level.
`String`
`getCompressionType()`
Returns the currently set compression type, or `null` if none has been set.
`String[]`
`getCompressionTypes()`
Returns a list of available compression types, as an array or `String`s, or `null` if a compression type may not be chosen using these interfaces.
`Locale`
`getLocale()`
Returns the currently set `Locale`, or `null` if only a default `Locale` is supported.
`String`
`getLocalizedCompressionTypeName()`
Returns a localized version of the name of the current compression type, using the `Locale` returned by `getLocale`.
`Dimension[]`
`getPreferredTileSizes()`
Returns an array of `Dimension`s indicating the legal size ranges for tiles as they will be encoded in the output file or stream.
`int`
`getProgressiveMode()`
Returns the current mode for writing the stream in a progressive manner.
`int`
`getTileGridXOffset()`
Returns the horizontal tile grid offset of an image as it will be written to the output stream.
`int`
`getTileGridYOffset()`
Returns the vertical tile grid offset of an image as it will be written to the output stream.
`int`
`getTileHeight()`
Returns the height of each tile in an image as it will be written to the output stream.
`int`
`getTileWidth()`
Returns the width of each tile in an image as it will be written to the output stream.
`int`
`getTilingMode()`
Returns the current tiling mode, if tiling is supported.
`boolean`
`isCompressionLossless()`
Returns `true` if the current compression type provides lossless compression.
`void`
`setCompressionMode(int mode)`
Specifies whether compression is to be performed, and if so how compression parameters are to be determined.
`void`
`setCompressionQuality(float quality)`
Sets the compression quality to a value between `0` and `1`.
`void`
`setCompressionType(String compressionType)`
Sets the compression type to one of the values indicated by `getCompressionTypes`.
`void`
`setProgressiveMode(int mode)`
Specifies that the writer is to write the image out in a progressive mode such that the stream will contain a series of scans of increasing quality.
`void`
`setTiling(int tileWidth, int tileHeight, int tileGridXOffset, int tileGridYOffset)`
Specifies that the image should be tiled in the output stream.
`void`
`setTilingMode(int mode)`
Determines whether the image will be tiled in the output stream and, if it will, how the tiling parameters will be determined.
`void`
`unsetCompression()`
Removes any previous compression type and quality settings.
`void`
`unsetTiling()`
Removes any previous tile grid parameters specified by calls to `setTiling`.

### Methods declared in class IIOParam

`activateController, getController, getDefaultController, getDestinationOffset, getDestinationType, getSourceBands, getSourceRegion, getSourceXSubsampling, getSourceYSubsampling, getSubsamplingXOffset, getSubsamplingYOffset, hasController, setController, setDestinationOffset, setDestinationType, setSourceBands, setSourceRegion, setSourceSubsampling`
Modifier and Type
Method
Description
`boolean`
`activateController()`
Activates the installed `IIOParamController` for this `IIOParam` object and returns the resulting value.
`IIOParamController`
`getController()`
Returns whatever `IIOParamController` is currently installed.
`IIOParamController`
`getDefaultController()`
Returns the default `IIOParamController`, if there is one, regardless of the currently installed controller.
`Point`
`getDestinationOffset()`
Returns the offset in the destination image at which pixels are to be placed.
`ImageTypeSpecifier`
`getDestinationType()`
Returns the type of image to be returned by the read, if one was set by a call to `setDestination(ImageTypeSpecifier)`, as an `ImageTypeSpecifier`.
`int[]`
`getSourceBands()`
Returns the set of source bands to be used.
`Rectangle`
`getSourceRegion()`
Returns the source region to be used.
`int`
`getSourceXSubsampling()`
Returns the number of source columns to advance for each pixel.
`int`
`getSourceYSubsampling()`
Returns the number of rows to advance for each pixel.
`int`
`getSubsamplingXOffset()`
Returns the horizontal offset of the subsampling grid.
`int`
`getSubsamplingYOffset()`
Returns the vertical offset of the subsampling grid.
`boolean`
`hasController()`
Returns `true` if there is a controller installed for this `IIOParam` object.
`void`
`setController(IIOParamController controller)`
Sets the `IIOParamController` to be used to provide settings for this `IIOParam` object when the `activateController` method is called, overriding any default controller.
`void`
`setDestinationOffset(Point destinationOffset)`
Specifies the offset in the destination image at which future decoded pixels are to be placed, when reading, or where a region will be written, when writing.
`void`
`setDestinationType(ImageTypeSpecifier destinationType)`
Sets the desired image type for the destination image, using an `ImageTypeSpecifier`.
`void`
`setSourceBands(int[] sourceBands)`
Sets the indices of the source bands to be used.
`void`
`setSourceRegion(Rectangle sourceRegion)`
Sets the source region of interest.
`void`
`setSourceSubsampling(int sourceXSubsampling, int sourceYSubsampling, int subsamplingXOffset, int subsamplingYOffset)`
Specifies a decimation subsampling to apply on I/O.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### BMPImageWriteParam

public BMPImageWriteParam(Locale locale)
Constructs a `BMPImageWriteParam` set to use a given `Locale` and with default values for all parameters.

Parameters:
  `locale` - a `Locale` to be used to localize compression type names and quality descriptions, or `null`.

### BMPImageWriteParam

public BMPImageWriteParam()
Constructs an `BMPImageWriteParam` object with default values for all parameters and a `null Locale`.

## Method Details

### setTopDown

public void setTopDown(boolean topDown)
If set, the data will be written out in a top-down manner, the first scanline being written first.

Parameters:
  `topDown` - whether the data are written in top-down order.

### isTopDown

public boolean isTopDown()
Returns the value of the `topDown` parameter. The default is `false`.

Returns:
  whether the data are written in top-down order.